#include "license.h" 
#include <string.h>

gchar feedback_code[64] ;
gchar feedback_buf[40];
int ret;
static void export_button_clicked(GtkButton* window, gpointer data);
GtkWidget *export_window; 
void close_export_button(GtkWidget *window, gpointer data)
{
    gtk_widget_show_all((GtkWidget *)data);
    gtk_widget_destroy(export_window);
    gtk_status_icon_set_visible (lic_tray_icon, TRUE);
    gtk_main_quit();
    export_window=NULL;
}
void export_feedback_code(GtkWidget *widget,gpointer data)
{
    GtkWidget *button,*fixed;
    GtkWidget *vbox;
    GtkWidget *feedback_code_label; 
    gchar fbcode_buf[40];

    memset(feedback_buf,0,40);
    memset(feedback_code,0,64);
    ret = g_lic_gen_fbcode_cli(0, feedback_buf);    
        
    gtk_widget_hide_all((GtkWidget *)data);    
    export_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    SET_ICON(export_window);
    gtk_window_set_title(GTK_WINDOW(export_window), _N("Export the Registration File"));
    gtk_container_set_border_width(GTK_CONTAINER(export_window),10);
    
    SET_BG(export_window);
   // gtk_window_set_default_size(GTK_WINDOW(export_window),WIDTH,HEIGHT);
    gtk_widget_set_size_request(export_window,WIDTH,HEIGHT);
    FIXED_WINDOW(export_window);
    gtk_window_set_position(export_window,GTK_WIN_POS_CENTER_ALWAYS); 
    vbox = gtk_vbox_new(FALSE,10);
     
    fixed = gtk_fixed_new();    
 
    button = gtk_button_new_with_label(_N("Export To ..."));
    //gtk_fixed_put(fixed,button,5,5);    

    gtk_widget_set_size_request(button,40,40);
    g_signal_connect(GTK_OBJECT(button),"clicked", GTK_SIGNAL_FUNC(export_button_clicked),data);
    g_signal_connect(GTK_OBJECT(export_window),"destroy",GTK_SIGNAL_FUNC(close_export_button),data);
    
    fill_line(feedback_buf,fbcode_buf,ret+1);
    sprintf(feedback_code,"%s%s\n",_N("Registration Number:"), fbcode_buf); 

    feedback_code_label = gtk_label_new(feedback_code);
    //gtk_label_set_label(feedback_code_label,feedback_code); 
    gtk_box_pack_start(GTK_BOX(vbox),feedback_code_label,FALSE,FALSE,5);
    //gtk_box_pack_start(GTK_BOX(vbox),fixed,FALSE,FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),button,FALSE,FALSE,5);
    gtk_container_add(GTK_CONTAINER(export_window), vbox);

    SET_BG(fixed);    
    SET_BG(vbox);    
    SET_BG(button);    

    gtk_widget_show_all(export_window);
    if(!ret) 
    {
        push_message_dialog(_N("Cannot obtain Registration File"),EXPORTTITLE);
        close_export_button(export_window, data);    
    }
    gtk_main();
    export_window=NULL;
}
void push_message_dialog( gchar *information,gchar *titleInfor)
{
    GtkWidget *dialog;
    dialog = gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, information);
    gtk_window_set_title (GTK_WINDOW (dialog), titleInfor);
    SET_BG(dialog);
    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);
}
static void export_button_clicked(GtkButton* window, gpointer data)
{
    GtkWidget *dialog;
    gchar *filename;
    FILE *fp = NULL;
    char file_fullname[512];
    verify(); 
    gtk_status_icon_set_visible (lic_tray_icon, FALSE);
    if(auth_result){
    dialog = gtk_file_chooser_dialog_new(_N("Save File As ..."), window,
                                        GTK_FILE_CHOOSER_ACTION_SAVE,
                                        GTK_STOCK_CANCEL,GTK_RESPONSE_CANCEL,
                                        GTK_STOCK_SAVE,GTK_RESPONSE_ACCEPT,
                                        NULL);
    SET_ICON(dialog);
    //gtk_file_chooser_set_current_name(dialog, "license");
    gtk_file_chooser_set_current_name(dialog, "feedback.txt");
    gint result = gtk_dialog_run(GTK_DIALOG(dialog));
    if (result == GTK_RESPONSE_ACCEPT)
    {
       filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
       strcpy(file_fullname,filename);
       //strcat(file_fullname,"ver.dat");
       fp = g_fopen(file_fullname, "w");
       if (fp == NULL)
       {
            sprintf(file_fullname,"Cannot open file:%s",filename);
            push_message_dialog(file_fullname,EXPORTTITLE );
            gtk_widget_destroy(dialog);
            
       } 
       else{
           fwrite(feedback_buf, strlen(feedback_buf), 1, fp);
           gtk_widget_destroy(dialog);
           push_message_dialog(_N("Save Successful"),EXPORTTITLE ); 
           fclose(fp);
        }
        fp = NULL;
    }
    else
        gtk_widget_destroy(dialog);
   }
    close_export_button(window,data);
}                                       
