#include <signal.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>

#define LOCKMODE (S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)

int lockfile(int ff)
{
    struct flock fl;
    
    fl.l_type = F_WRLCK;
    fl.l_start = 0;
    fl.l_whence = SEEK_SET;
    fl.l_len = 0;
    return(fcntl(ff,F_SETLK,&fl));
}
int already_running(char *file)
{
  int fd;
  char buf[16];
  char filename[30];   
  
  umask(0x000);
  fd = open(file, O_RDWR|O_CREAT,S_IRWXU|S_IRWXG|S_IRWXO);  
  if (fd < 0)
  {
    syslog(LOG_ERR,"can't open %s:%s\n",file,strerror(errno));
    exit(1);
  }   
  if (lockfile(fd) < 0)
  {
     if(errno == EACCES ||errno == EAGAIN)
     {
        close(fd);
        return 1;
     }
    syslog(LOG_ERR,"can't lock %s:%s\n",file,strerror(errno));
    exit(1);
  }
  ftruncate(fd,0);
  sprintf(buf, "%ld", (long)getpid());
  write(fd,buf,strlen(buf) + 1);
  return 0;
}
void init_daemon(void)
{
  int pid;
  int i;
  if(pid=fork())
      exit(0);        //是父进程，结束父进程
  else if(pid < 0)
      exit(1);        //fork失败，退出
  setsid();           //第一子进程成为新的会话组长和进程组长
      //并与控制终端分离
  if(pid=fork())
      exit(0);        //是第一子进程，结束第一子进程
  else if(pid< 0)
      exit(1);        //fork失败，退出
      //是第二子进程，继续
      //第二子进程不再是会话组长
  for(i=0;i< NOFILE;++i)  //关闭打开的文件描述符
     close(i);

//  chdir("/tmp");      //改变工作目录到/tmp
  umask(0);           //重设文件创建掩模
  return;
}
int create_single_process()
{
     init_daemon();
     /*if (already_running() != 0)
     {
        exit(1);
     }*/
     return 0;
}

