#include "license.h"
extern gboolean lic_view_window_show (GtkWidget * widget, gpointer data);
extern gboolean lic_help_window_show (GtkWidget * widget, gpointer data);
extern gboolean lic_about_dialog_show (GtkWidget * widget, gpointer data);
     
GtkStatusIcon *lic_tray_icon;
gboolean
lic_tray_icon_on_left_menu (GtkStatusIcon * status_icon,
			    GtkWidget * left_menu)
{
  gtk_widget_show_all (left_menu);
  gtk_menu_popup (GTK_MENU (left_menu), NULL, NULL,
		  gtk_status_icon_position_menu, status_icon, GDK_LEFTBUTTON,
		  gtk_get_current_event_time ());

  return TRUE;
}

static gboolean
lic_tray_icon_on_right_menu (GtkStatusIcon * status_icon, guint button,
			     guint activate_time, GtkWidget * right_menu)
{
  g_return_val_if_fail (GTK_IS_MENU (right_menu), FALSE);
  gtk_widget_show_all (right_menu);
  gtk_menu_popup (GTK_MENU (right_menu), NULL, NULL,
		  gtk_status_icon_position_menu, status_icon, button,
		  gtk_get_current_event_time ());
  return TRUE;
}

static GtkStatusIcon *
create_lic_tray_icon ()
{
  lic_tray_icon = gtk_status_icon_new_from_file (icon_file);	/* lic_tray_icon as the entry of GUI */

  /* 需要根据认证状态处理下面的输入。switch */
  // gtk_status_icon_set_from_icon_name(lic_tray_icon, GTK_STOCK_OK);
  //gtk_status_icon_set_tooltip(lic_tray_icon, "Example Tray Icon");
  gtk_status_icon_set_visible (lic_tray_icon, TRUE);

  g_signal_connect (lic_tray_icon, "activate",
		    G_CALLBACK (lic_view_window_show), NULL);
  /* 
     GtkWidget  * left_menu, * right_menu;

     left_menu=gtk_menu_new();
     right_menu=gtk_menu_new();
     GtkWidget *menuitemView = gtk_menu_item_new_with_label("View");
     g_signal_connect(menuitemView,"activate", G_CALLBACK(lic_view_window_show),NULL);
     gtk_menu_append(GTK_MENU(left_menu),menuitemView);

     GtkWidget *menuitemHelp = gtk_menu_item_new_with_label("Help");
     g_signal_connect(menuitemHelp,"activate", G_CALLBACK(lic_help_window_show),NULL);

     GtkWidget *menuitemAbout = gtk_menu_item_new_with_label("About");
     g_signal_connect(menuitemAbout,"activate", G_CALLBACK(lic_about_dialog_show),NULL);
     gtk_menu_append(GTK_MENU(right_menu), menuitemHelp);
     gtk_menu_append(GTK_MENU(right_menu), menuitemAbout);

     g_signal_connect(G_OBJECT(lic_tray_icon), "activate", 
     G_CALLBACK(lic_tray_icon_on_left_menu), left_menu);
     g_signal_connect(G_OBJECT(lic_tray_icon), "popup-menu",
     G_CALLBACK(lic_tray_icon_on_right_menu), right_menu);
   */

  return lic_tray_icon;
}

void
button_clicked (gchar * information)
{
  GtkWidget *dialog;
  dialog = gtk_message_dialog_new (NULL,
				   GTK_DIALOG_DESTROY_WITH_PARENT,
				   GTK_MESSAGE_WARNING,
				   GTK_BUTTONS_OK, information);
  SET_BG (dialog);
  SET_ICON (dialog);

  gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);

}

int
update_license_status ()
{
  int license_chk, expiry_chk;
  int daysleft;
  int license_status;

  license_chk = lic_chk_license_validity ();
  expiry_chk = lic_chk_trial_expiry (&daysleft);

  if (!license_chk)
    {
      license_status = 1;
      icon_file = GREEN_ICON;

    }
  else if (!expiry_chk)
    {
      license_status = 2;
      icon_file = YELLOW_ICON;
    }
  else
    {
      license_status = 3;
      icon_file = RED_ICON;
    }
  return license_status;

}
int
main (int argc, char **argv)
{

  setlocale (LC_ALL, "");
  bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
  textdomain (GETTEXT_PACKAGE);
  if (lic_chk_license_validity() && fork () == 0)
    {
      char buf[512];
      int i, pid, status;
      init_daemon ();
      if (already_running (LOCKFILE2) != 0)
	exit (1);
      while (1)
	if (pid = fork ())
	  {
	    waitpid (pid, &status, 0);
	    sleep (60);
	    if (!lic_chk_license_validity())
	      {
		exit (0);
	      }
	  }
	else
	  {
        printf("2.g_lic_show_lic_status_cli (buf) = %d\n",g_lic_show_lic_status_cli (buf));
	    if (g_lic_show_lic_status_cli (buf))
	      {
		gtk_init (&argc, &argv);
		button_clicked (_N
				("Sorry! Your trial period has expired.If you would like to purchase a license, please contact our customer service.\nPhone Number：400-089-1870 \nE-mail Address：register@kylinos.cn"));
	      }
	    exit (0);
	  }
    }
  else
    {
      // init_daemon ();
      if (already_running (LOCKFILE) != 0)
	exit (1);
      /* printf("pid = %d\n",getppid()); */
      setlocale (LC_ALL, "");
      bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
      textdomain (GETTEXT_PACKAGE);
      gtk_init (&argc, &argv);
      update_license_status ();
      /* Initialize GTK+ and all of its supporting libraries */
      gtk_init (&argc, &argv);
      lic_tray_icon = create_lic_tray_icon ();
      /* Hand control over to the main loop */
      gtk_main ();
      return 0;
    }
}
