#include "license.h" 
#include "common.h"

GtkWidget *main_window = NULL;
void export_feedback_code(GtkWidget *widget, gpointer data);
void import_feedback_code(GtkWidget *widget, gpointer data);
void closeApp(GtkWidget *window, gpointer data)
{
    gtk_main_quit();
    main_window=NULL;
}

void update_widget_bg(GtkWidget *widget, gchar *img_file)
{       
	GtkStyle *style;     
	GdkPixbuf *pixbuf;       
	GdkPixmap *pixmap;     
	gint width, height;    

	pixbuf = gdk_pixbuf_new_from_file(img_file, NULL);    
	width = gdk_pixbuf_get_width(pixbuf);		
	height = gdk_pixbuf_get_height(pixbuf);    
	pixmap = gdk_pixmap_new(NULL, width, height, 24);   
	gdk_pixbuf_render_pixmap_and_mask(pixbuf, &pixmap, NULL, 0);
	style = gtk_style_copy(GTK_WIDGET (widget)->style);    


	if (style->bg_pixmap[GTK_STATE_NORMAL])        
	g_object_unref(style->bg_pixmap[GTK_STATE_NORMAL]);    

	style->bg_pixmap[GTK_STATE_NORMAL] = g_object_ref(pixmap);    
	style->bg_pixmap[GTK_STATE_ACTIVE] = g_object_ref(pixmap);
	style->bg_pixmap[GTK_STATE_PRELIGHT] = g_object_ref(pixmap);
	style->bg_pixmap[GTK_STATE_SELECTED] = g_object_ref(pixmap);
	style->bg_pixmap[GTK_STATE_INSENSITIVE] = g_object_ref(pixmap);
	gtk_widget_set_style(GTK_WIDGET (widget), style);
	g_object_unref(style);

}

void update_icon()
{
    GdkPixbuf *pixbuf;
    update_license_status();
    pixbuf = gdk_pixbuf_new_from_file(icon_file, NULL);
    gtk_status_icon_set_from_pixbuf (lic_tray_icon,pixbuf);
}

/*
 * 根据系统的release和productinfo信息
 * 获取当前系统的ProductID
 */
/*static int get_PID()
{
	FILE *fp_release =NULL;
	FILE *fp_proInfo = NULL;
	char *buf_r = NULL;
	char *buf_p = NULL;
	int len_r = -1;
	int len_p = -1;
	int Vstr_len =strlen(VIRTUALMARK);
	int Astr_len =strlen(ADVMARK);
	int Gstr_len =strlen(GENMARK);
	//int VF_len =strlen(VIRTFLAG);
	int R_len =strlen(RELEASE);
	
	int ret = EXIT_UNKNOWN_PLATFORM	;
	ssize_t  len = 256;

	fp_release = fopen(NKRELEASE,"r");
	fp_proInfo = fopen(NKPRODUCTINFO,"r");
	if(!fp_proInfo||!fp_release )
		goto End;
	
	len_r = getline(&buf_r, &len,fp_release);
	if(len_r < 0 || len_r ==0 )
		goto End;
	len_p = getline(&buf_p, &len, fp_proInfo);
	if(len_p < 0 ||len_p ==0 )
		goto End;

	if((strncmp(buf_r,VIRTUALMARK, Vstr_len)==0) && 
	   (strncmp(buf_r+sizeof(VIRTUALMARK),RELEASE,R_len)==0)) {
		goto VIRT_P;
	}
	
	if((strncmp(buf_r,GENMARK, Gstr_len)==0) && 
	   (strncmp(buf_r+sizeof(GENMARK),RELEASE,R_len)==0)) {
		goto GEN_P;
	}

	if((strncmp(buf_r,ADVMARK,Astr_len)==0) && 
	   (strncmp(buf_r+sizeof(ADVMARK),RELEASE,R_len)==0)){
		goto ADV_P;
	}
	goto End;

VIRT_P:
	if( strncmp(buf_p,VIRTUALMARK, Vstr_len)==0 ) {
		ret = PID_VIRTUAL ;
	}
	goto End;

GEN_P:
	if( (strncmp(buf_p,GENMARK, Gstr_len)==0 ) && 
		(strncmp(buf_p,VIRTUALMARK, Vstr_len)!=0)) {
		ret = PID_GENER;
	}
	goto End;

ADV_P: 
	if( (strncmp(buf_p,ADVMARK,Astr_len)==0) && 
		(strncmp(buf_p,VIRTUALMARK, Vstr_len)!=0)) {
		ret = PID_ADVAN ;
//		goto End;
	}

End:

	if(fp_release){
		fclose(fp_release);
		fp_release=NULL;
	}
	if(fp_proInfo) {
		fclose(fp_proInfo);
		fp_proInfo = NULL;
	}
	if(buf_r){
		free(buf_r);
		buf_r=NULL;
	}
	if(buf_p){
		free(buf_p);
		buf_p=NULL;
	}
	  
	return	 ret;
}*/

int read_release_info(char *buf)
{
	int pid =0;
	pid = get_PID();

	switch(pid) {
		case PID_GENER:
			sprintf(buf, _N("Name: NeoKylin Linux General Server"));
			break;

		case PID_ADVAN:
			sprintf(buf,_N("Name: Kylin Linux Advanced Server"));
			break;

//		case PID_ADVAN_V7:
		case PID_ADVAN_V7_AND_V10:
			sprintf(buf,_N("Name: Kylin Linux Advanced Server"));
			break;

		case PID_VIRTUAL:
			sprintf(buf,_N("Name: Kylin Linux Advanced Server (Virtualization Edition)"));
			break;

		case PID_VIRTUAL_V7:
			sprintf(buf,_N("Name: Kylin Linux Advanced Server (Virtualization Edition)"));
			break;

		default:
			sprintf(buf,_N("Name: Get Production_Info Error!"));
	}
	return 0;
}

extern int install_time(char*);
int join_license_info(char *buf)
{
    int daysleft;
    char days[30];
    gchar release[128];
    struct tm *license_verify_time;
    gchar clicense_verify_time[30];
    gchar clicense_machinetype_chstr[80];
    memset(clicense_machinetype_chstr, 0, 80);
    int machinetype_chflag = 0;
    int license_chk;
    int customer_chk;

    read_release_info(release); 
    license_chk = lic_chk_license_validity_stat_v2(&machinetype_chflag);

    char customerinfo[80];
    memset(customerinfo,0,80);
    if (!license_chk) {
        customer_chk = lic_chk_licfile_validity_customerinfo(customerinfo);
    } else {
        customer_chk = -1;
    }

    //if(!lic_chk_license_validity()) {
    if(!license_chk) {
#ifndef  NOKEY_PLATFORM
    
		if(!lic_chk_ukey_validity()){
        	sprintf(clicense_verify_time,_N("Trusted Time: Ukey"));
		}
		else{	
#endif	
			gchar ctime[12];
			time_t installtime;
			install_time(ctime); 
			installtime = strtoul(ctime, NULL, strlen(ctime));
			license_verify_time = localtime(&installtime); 
			if(license_verify_time != NULL)
				sprintf(clicense_verify_time,
						_N("Trusted Time: %d/%d/%d"),
						license_verify_time->tm_mon + 1,
						license_verify_time->tm_mday,
						license_verify_time->tm_year+1900);
			else  
				sprintf(clicense_verify_time,_N("Trusted Time: %d/%d/%d"),0,0,0);
			if (machinetype_chflag) {
                        	if (machinetype_chflag == 5) {
					//sprintf(clicense_machinetype_chstr, "告警：license 中CPU数量与本机实际CPU数量不符。\n");
					sprintf(clicense_machinetype_chstr, _N("Warning: The CPU's number of the target is differnent from the license.\n"));
                        	} else { /*1 2 3 etc.*/
					//sprintf(clicense_machinetype_chstr, "告警：license中主机类型与本机实际主机类型不符。\n");
					sprintf(clicense_machinetype_chstr, _N("Warning: The machine type of the target is different from the license.\n"));
                        	}
                	}

#ifndef  NOKEY_PLATFORM
		}
#endif

		if (customer_chk == 0 && customerinfo) {
			gchar str_customerinfo[80];
			sprintf(str_customerinfo, _N("Licensed to: %s\n"), customerinfo);
			sprintf(buf,"%s\n%s\n%s%s", release,_N("License Status: Legitimate Authorized"),clicense_machinetype_chstr, str_customerinfo);
		} else  {
		//sprintf(buf,"%s\n%s\n%s\n", release,_N("License Status: Legitimate Authorized"),clicense_verify_time);
		sprintf(buf,"%s\n%s\n%s%s\n", release,_N("License Status: Legitimate Authorized"),clicense_machinetype_chstr, clicense_verify_time);
		}
        contact_info =CONTACT_INFO;
    }
    else if( !lic_chk_trial_expiry(&daysleft)) {
        sprintf(days,_N("Time Remaining: %d Day(s)"),daysleft);
        sprintf(buf,"%s\n%s\n%s\n%s\n", release,_N("License Status: Unauthorized"),_N("Trusted Time:     "),days);
        contact_info =CONTACT_INFO_UNREGISTER;
    }
	else {
        sprintf(days,_N("Time Remaining: %d Day(s)"),0);
        sprintf(buf,"%s\n%s\n%s\n%s\n", release,_N("License Status: Unauthorized"),_N("Trusted Time:     "),days);
        contact_info =CONTACT_INFO_UNREGISTER;
   } 
}
gboolean lic_view_window_show(GtkWidget *widget, gpointer data)
{
   
    GtkWidget *hbox1;//,*hbox2;
    GtkWidget *vbox;
    GdkPixbuf *pixbuf;
   
    if(main_window != NULL)
  	return 1;
    if(import_window != NULL)
	return 1;
    if(export_window!=NULL)
	return 1;	
   update_icon(); 
    main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    join_license_info(register_info);
    SET_ICON(main_window);
    SET_BG(main_window);
    gtk_window_set_title(GTK_WINDOW(main_window), _N("License Manager"));
    gtk_window_set_position(GTK_WINDOW(main_window),GTK_WIN_POS_CENTER);
    gtk_widget_set_size_request(main_window,WIDTH,HEIGHT);
    FIXED_WINDOW(main_window);

    gtk_container_set_border_width(GTK_CONTAINER(main_window),10);

    g_signal_connect(GTK_OBJECT(main_window),"destroy",GTK_SIGNAL_FUNC(closeApp),main_window);
    license_label = gtk_label_new(NULL);
    contact_label= gtk_label_new(NULL);
    
    hbox1 = gtk_hbox_new(TRUE,5);
    vbox = gtk_vbox_new(FALSE,10);

    import = gtk_button_new_with_label(_N("Import Authorization File"));
    export = gtk_button_new_with_label(_N("Export Registration File"));
    SET_BG(export);
    SET_BG(import);

    g_signal_connect(GTK_OBJECT(export),"clicked",GTK_SIGNAL_FUNC(export_feedback_code),(gpointer)main_window);
    g_signal_connect(GTK_OBJECT(import),"clicked",GTK_SIGNAL_FUNC(import_feedback_code),(gpointer)main_window);
    

    markerup = g_markup_printf_escaped ("<span style=\"normal\" font=\"12.5\">%s</span>", register_info); 
    gtk_label_set_label(license_label,register_info);
    gtk_label_set_label(contact_label,contact_info);
    gtk_box_pack_start(GTK_BOX(vbox),license_label,FALSE,FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),contact_label,FALSE,FALSE,5);

    gtk_box_pack_start(GTK_BOX(hbox1),export,TRUE,FALSE,5);
    gtk_box_pack_start(GTK_BOX(hbox1),import,TRUE,FALSE,5);
    gtk_box_pack_start(GTK_BOX(vbox),hbox1,FALSE,FALSE,5);
    
    gtk_container_add(GTK_CONTAINER(main_window), vbox);
    if(!lic_chk_license_validity())
    {
        gtk_widget_set_sensitive (export, FALSE);
        gtk_widget_set_sensitive (import, FALSE);
    }
    gtk_widget_show_all(main_window);
    gtk_main();
    main_window=NULL;
    return 0;
}

